exemplo_01/exemplo_01/urls.py
from django.contrib import admin
from django.urls import path,include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('hello/', include('hello.urls')),
    path('newyear/', include('newyear.urls')),
    path('tasks/', include('tasks.urls')),
    path('flights/', include('flights.urls')),
]

exemplo_01/flights/urls.py
from django.urls import path
from flights import views

app_name = 'flights'

urlpatterns = [
    path("", views.index, name="index")
]

exemplo_01/hello/urls.py
from django.urls import path
from hello import views

urlpatterns = [
    path("", views.index, name="index"),
    path("lucas", views.lucas, name="lucas"),
    path("<str:name>", views.greet, name="greet"),
    path("templ/<str:name>", views.greet_with_template, name="greet_2"),
]

exemplo_01/newyear/urls.py
from django.urls import path
from newyear import views

urlpatterns = [
    path("", views.index, name="index"),
]

exemplo_01/tasks/urls.py
from django.urls import path
from tasks import views

app_name = 'tasks'

urlpatterns = [
    path("", views.index, name="index"),
    path("add", views.add, name="add"),
]

exemplo_01/flights/models.py
from operator import mod
from django.db import models
from django.template import Origin

# Create your models here.
class Airport(models.Model):
    code = models.CharField(max_length=3)
    city = models.CharField(max_length=64)

    def __str__(self):
        return f'{self.city} ({self.code})'


class Flight(models.Model):
    origin = models.ForeignKey(Airport, on_delete=models.CASCADE, related_name="departures")
    destination = models.ForeignKey(Airport, on_delete=models.CASCADE, related_name="arrivals")
    duration = models.IntegerField()

    def __str__(self):
        return f'{self.id}: {self.origin}, {self.destination}, {self.duration}'

exemplo_01/hello/models.py
from django.db import models

# Create your models here.

exemplo_01/newyear/models.py
from django.db import models

# Create your models here.

exemplo_01/tasks/models.py
from django.db import models

# Create your models here.

exemplo_01/flights/views.py
from django.http import HttpResponse
from django.shortcuts import render

from flights.models import Flight

# Create your views here.
def index(request):
    return render(request, "flights/index.html", {
        'flights': Flight.objects.all()
    })

exemplo_01/hello/views.py
from django.http import HttpResponse
from django.shortcuts import render

# Create your views here.
def index(request):
    return render(request, "hello/index.html")

def lucas(request):
    return HttpResponse('Hello, Lucas')

def greet(request, name):
    return HttpResponse(f'Hello, {name}')

def greet_with_template(request, name):
    return render(request, 'hello/greet.html', {
        'name': name.capitalize()
    })

exemplo_01/newyear/views.py
from django.shortcuts import render
from datetime import datetime 

# Create your views here.

def index(request):
    now = datetime.now()
    return render(request, 'newyear/index.html', {
        'is_newyear': now.day == 1 and now.month == 1
    })

exemplo_01/tasks/views.py
from django import forms
from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import render
from django.urls import reverse

# Create your views here.

class NewTaskForm(forms.Form):
    task = forms.CharField(label="new task")
    # priority = forms.IntegerField(label="Priority", min_value=0, max_value=10)


def index(request):
    if "tasks" not in request.session:
        request.session['tasks'] = []

    return render(request, 'tasks/index.html', {
        'tasks': request.session['tasks']
    })

def add(request):
    if request.method == 'POST':
        form = NewTaskForm(request.POST)
        if form.is_valid():
            task = form.cleaned_data['task']
            request.session['tasks'] += [task]
            return HttpResponseRedirect(reverse("tasks:index"))
        else:
            return render(request, 'tasks/add.html', {
                'form': form
            })
    return render(request, 'tasks/add.html', {
        'form': NewTaskForm()
    })

exemplo_01/flights/templates/flights/index.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Flights</title>
</head>
<body>
    <h1>Flights</h1>
    
    {% for flight in flights %}
        <li>Flight {{ flight.id }}: {{ flight.origin }} to {{ flight.destination }}</li>
    {% endfor %}
</body>
</html>

exemplo_01/hello/templates/hello/greet.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    <h1>Hello, {{ name }}</h1>
</body>
</html>

exemplo_01/hello/templates/hello/index.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    <h1>hello, world!!</h1>
</body>
</html>

exemplo_01/newyear/templates/newyear/index.html
{% load static %}

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="{% static 'newyear/styles.css' %}">
</head>
<body>
    {% if is_newyear %}
        <h1>YES</h1>
    {% else %}
        <h1>NO</h1>
    {% endif %}
    <button onclick="test()">DIGA OI</button>
    <script src="{% static 'newyear/script.js' %}"></script>
</body>
</html>

exemplo_01/tasks/templates/tasks/add.html
{% extends "tasks/layout.html" %}

{% block body %}
    <h1>ADD task</h1>
    <form action="{% url 'tasks:add' %}" method="POST">
        {% csrf_token %}
        {{ form }}
        <input type="submit">
    </form>

    <!-- coloquei o nome da app para não ter colisão de nome com outras apps... tem que colocar a variável app_name no arquivo urls.py -->
    <a href="{% url 'tasks:index' %}">back to tasks</a>
{% endblock %}

exemplo_01/tasks/templates/tasks/index.html
{% extends "tasks/layout.html" %}

{% block body %}
    <h1>Tasks</h1>
    <ul>
    {% for task in tasks %}
        <li>{{ task }}</li>
    {% empty %}
        <li>No tasks.</li>
    {% endfor %}
    </ul>
    
    <!-- coloquei o nome da app para não ter colisão de nome com outras apps... tem que colocar a variável app_name no arquivo urls.py -->
    <a href="{% url 'tasks:add' %}">add new task</a>

{% endblock %}

exemplo_01/tasks/templates/tasks/layout.html
{% load static %}

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="{% static 'newyear/styles.css' %}">
</head>
    <body>
        {% block body %}
        {% endblock %}
    </body>
</html>